Bug 573672 - DynLib::load forces .so suffix
Summary: DynLib::load forces .so suffix
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: ogre
Version: 18
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Bruno Wolff III
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-03-15 14:40 UTC by Karel Volný
Modified: 2014-02-05 23:16 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-02-05 23:16:21 UTC


Attachments (Terms of Use)

Description Karel Volný 2010-03-15 14:40:11 UTC
Description of problem:
Ogre refuses to load (cannot find) plugins that do not end in ".so"
This is in violation with Fedora library naming scheme, as it does not allow specifying plugin version using .x.y.z suffix.

Version-Release number of selected component (if applicable):
ogre-1.6.4-3.fc12

How reproducible:
always

Steps to Reproduce:
please see the source code of OgreDynLib.cpp
  
Actual results:
#if OGRE_PLATFORM == OGRE_PLATFORM_LINUX                                                                                                                     
        // dlopen() does not add .so to the filename, like windows does for .dll                                                                             
        if (name.substr(name.length() - 3, 3) != ".so")                                                                                                      
           name += ".so";                                                                                                                                    
#endif                                                                                                                                                       

Expected results:
no such hardcoded filename rules

Additional info:
Note, I report against Fedora nad not upstream because of the ".so only in -devel packages" policy, don't know if other distros allow unversioned files hanging around ...

Comment 1 Bruno Wolff III 2010-03-15 15:28:17 UTC
Is this causing a real problem right now for you, or is this something that just needs to get fixed eventually?

Comment 2 Karel Volný 2010-03-16 13:21:00 UTC
I'm trying to package FreeOrion, which loads GiGi Ogre plugin via this function.

If I want to obey the guidelines, I have to put the unversioned symlink to the library into the -devel subpackage of GiGi. But then FreeOrion needs to depend on GiGi-devel. This is also against the rules, and brings a lot of other -devel dependencies ... So, effectively it blocks accepting the FreeOrion package.

In reality, this is just the first try with those packages, to have at least something working. There is a lot of other ugly hacks that should be solved with upstream. I'm really not sure when GiGi is going to be accepted. Until then, the -devel dependency is not a big problem, because FreeOrion can be accepted only after GiGi, and people interested will rebuild from source, having devel packages anyways.

Definitely not something that needs immediate fixing. But if you could do something about that when the next release comes, it'd be nice.

Comment 3 Bruno Wolff III 2010-03-16 15:01:39 UTC
I won't jump right on this since I have some higher priority stuff to get done this week. Also since it's a real problem, I'll put in a hack if I need to, to make it work. I think I saw some other related problem with plugins where sometimes they added .so and sometimes they didn't. But it's been a few months and I don't remember if it was ogre or paged geometry that had the issue.

Comment 4 Bruno Wolff III 2010-03-16 15:03:12 UTC
Another thing to be on the lookout for, is that there will probably be a major version bump for F14. I haven't checked real recently, but 1.7 was getting near done the last time I looked.

Comment 5 Bug Zapper 2010-11-03 19:37:49 UTC
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 6 Bug Zapper 2010-12-03 17:18:17 UTC
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 7 Karel Volný 2010-12-16 15:37:58 UTC
so ... the update did not happen yet, the bug is still valid

Comment 8 Fedora Admin XMLRPC Client 2011-06-20 22:29:00 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 9 Bruno Wolff III 2011-07-10 16:52:56 UTC
Does this still happen in F15 with the 1.7 release?

Comment 10 Karel Volný 2011-07-13 10:52:32 UTC
(In reply to comment #9)
> Does this still happen in F15 with the 1.7 release?

I haven't tried recompiling GiGi and FreeOrion in a while, but looking at the source code of OgreDynLib.cpp from ogre-1.7.3, the code in question hasn't changed

Comment 11 Fedora End Of Life 2012-08-07 20:11:18 UTC
This message is a notice that Fedora 15 is now at end of life. Fedora
has stopped maintaining and issuing updates for Fedora 15. It is
Fedora's policy to close all bug reports from releases that are no
longer maintained. At this time, all open bugs with a Fedora 'version'
of '15' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that
we were unable to fix it before Fedora 15 reached end of life. If you
would still like to see this bug fixed and are able to reproduce it
against a later version of Fedora, you are encouraged to click on
"Clone This Bug" (top right of this page) and open it against that
version of Fedora.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

The process we are following is described here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 12 Karel Volný 2012-08-08 11:13:33 UTC
we have still the buggy 1.7.3

Comment 13 Karel Volný 2013-02-01 11:26:30 UTC
still the same code in ogre-1.7.4

Comment 14 Bruno Wolff III 2013-04-20 10:40:39 UTC
I have committed a change to master that will first try plugin names as is, and if that fails and the name didn't end in .so, then it will retry with .so added.

This change should end up in f19+, though currently I don't have a new build.

Comment 15 Fedora Update System 2013-04-20 16:23:34 UTC
ogre-1.8.1-6.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ogre-1.8.1-6.fc19

Comment 16 Fedora Update System 2013-04-21 05:11:54 UTC
ogre-1.8.1-7.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ogre-1.8.1-7.fc19

Comment 17 Fedora Update System 2013-04-21 18:50:29 UTC
ogre-1.7.4-6.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ogre-1.7.4-6.fc18

Comment 18 Fedora Update System 2013-04-25 13:59:02 UTC
ogre-1.8.1-7.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2013-06-07 23:52:54 UTC
ogre-1.7.4-6.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 20 Fedora End Of Life 2013-12-21 15:39:57 UTC
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 21 Fedora End Of Life 2014-02-05 23:16:21 UTC
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.